using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Text;
using System.IO;
namespace Board
{
	/// <summary>
	/// Insert   Դϴ.
	/// </summary>
	public class Insert : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.CheckBox UseHTML;
		protected System.Web.UI.WebControls.TextBox txtName, txtPWD, txtMail, txtSubject, txtContent;
		protected System.Web.UI.WebControls.ImageButton btnSubmit;
		protected System.Web.UI.WebControls.Panel pnlContent;
		protected System.Web.UI.WebControls.Label lblContent;
		protected System.Web.UI.HtmlControls.HtmlInputImage OnSubmit;
		protected string Query = null, FileNames = null, FileSizes = null;
		protected string[] QueryArr;
		private bool ReplyFlag = false;
		public string TblName = null;

		Common.Function myFunction = new Common.Function();
		Common.DB myDB = new Common.DB();
		StringBuilder sb = new StringBuilder();

		private void Page_Load(object sender, System.EventArgs e)
		{
			TblName = Request.QueryString["TblName"];
			if (TblName == null || TblName == string.Empty) 
			{
				TblName = "Board";
			}

			if(!IsPostBack)
			{
				OnSubmit.Attributes.Add("onclick", "return OnSubmit();");
				if (Request.Params["thread"] != null) 
				{
					ViewState["thread"] = Request.Params["thread"].ToString();
				}

				if (Request.Params["depth"] != null) 
				{
					ViewState["depth"] = Request.Params["depth"].ToString();
				}

				if (Request.Params["seq"] != null) 
				{
					ViewState["seq"] = Request.Params["seq"].ToString();
					GetContent();
				}
			}

			if(ViewState["depth"] != null && ViewState["depth"] != null)
			{
				ReplyFlag = true;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.OnSubmit.ServerClick += new System.Web.UI.ImageClickEventHandler(this.OnSubmit_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/* 亯    */
		private void GetContent()
		{
			myDB.DbConn();
			Query = " SELECT subject, content, mode FROM "+ TblName
				+ " WHERE seq = '"+ ViewState["seq"].ToString() +"'";

			SqlDataReader Reader = myDB.FatechQuery(Query);

			if(Reader.Read())
			{
				txtSubject.Text = "[亯]" + Reader[0].ToString();
				bool HtmlMode = (bool)Reader[2];
				if(HtmlMode)
				{
					lblContent.Text = myFunction.ReplaceBR(Reader[1].ToString());
				}
				else
				{
					lblContent.Text = myFunction.ReplaceBR(Server.HtmlEncode(Reader[1].ToString()));
				}
				pnlContent.Visible = true;
				
			}
			else
			{
				myFunction.PrintMsgBack("  ʽϴ.");
			}

			myDB.ReaderClose();
			myDB.DbClose();
		}

		/*   Thread ȣ  */
		private int GetNewThread() 
		{
			Query = " SELECT ISNULL(MAX(Thread),0)+1000 FROM "+ TblName;		
			return myDB.TotalQuery(Query);
		}

		
		/* ε   */
		private void SaveToFile(string UploadDir, ref System.Web.HttpFileCollection UploadFile) 
		{
			string FileName, FileExt;
			int FileCnt;
			long FileSize;
			for (FileCnt = 0; FileCnt < UploadFile.Count; FileCnt++)
			{
				System.Web.HttpPostedFile CurFile = UploadFile.Get(FileCnt); 
				FileName = System.IO.Path.GetFileName(CurFile.FileName); 
				FileSize = CurFile.ContentLength / 1000;			// Kbyte 
				if(FileName != "")
				{ 
					FileExt = System.IO.Path.GetExtension(FileName); 
					if (FileExt == ".aspx" || FileExt == ".asp") 
					{
						myFunction.PrintMsgBack("Ȯڰ asp, aspx  ε ϽǼ ϴ.");
					} 
					else 
					{
						FileInfo saveFile;
						do 
						{
							saveFile = new FileInfo(UploadDir + FileName);
							if(saveFile.Exists)
							{
								FileName = FileName.Replace(".","1.");
							}
						}
						while(saveFile.Exists);
						FileNames += FileName + (char)5;
						FileSizes += FileSize.ToString() + (char)5;
						CurFile.SaveAs(UploadDir + FileName); 
					}
				} 
			}
		}

		/*  ư Ŭ */
		private void OnSubmit_ServerClick(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string UploadDir = Request.MapPath(".") + "\\Upload\\";	// ε 丮
			System.Web.HttpFileCollection UploadFile = System.Web.HttpContext.Current.Request.Files;
			SaveToFile(UploadDir, ref UploadFile);
			
			myDB.DbConn();
			string Content = txtContent.Text.Replace("'","''");

			if(ReplyFlag)	// 亯 ̶
			{
				int ParentThread = int.Parse(ViewState["thread"].ToString());
				int Depth = int.Parse(ViewState["depth"].ToString()) + 1;
				int PrevThread = (int.Parse(ViewState["thread"].ToString())-1)/1000 * 1000;
				int Thread = ParentThread - 1;
				string Query1, Query2;
				Query1 = " UPDATE "+ TblName +" SET thread = thread - 1 "
					+ "	Where thread < "+ParentThread+" AND thread > "+PrevThread;
			
				Query2 = " INSERT INTO "+ TblName +" ( "
					+ " thread, depth, writer, pwd, email, subject, mode, ip, content, FileName, FileSize "
					+ " ) VALUES ( "
					+ Thread +","
					+ Depth + ","
					+ "'"+ txtName.Text +"',"
					+ "'"+ txtPWD.Text +"',"
					+ "'"+ txtMail.Text +"',"
					+ "'"+ txtSubject.Text +"',"
					+ "'"+ (UseHTML.Checked == true ? 1 : 0) +"',"
					+ "'"+ Request.UserHostAddress +"',"
					+ "'"+ Content+"', "
					+ "'"+ FileNames +"', "
					+ "'"+ FileSizes +"')";

				
				myDB.InitTransaction("Reply");
				string[] QueryArr = new string[] { Query1, Query2 };

				myDB.ExecuteTransaction(QueryArr);
			}
			else		// ű   
			{
				myFunction.PrintMsg(ReplyFlag.ToString());
				int NewThread = GetNewThread();
				Query = " INSERT INTO "+ TblName +" ( " 
					+ "	thread, depth, writer, pwd, email, subject, mode, ip, content, FileName, FileSize "
					+ " ) VALUES ( "
					+ NewThread + ","
					+ "0,"
					+ "'"+ txtName.Text +"',"
					+ "'"+ txtPWD.Text +"',"
					+ "'"+ txtMail.Text +"',"
					+ "'"+ txtSubject.Text +"',"
					+ "'"+ (UseHTML.Checked == true ? 1 : 0) +"',"
					+ "'"+ Request.UserHostAddress +"',"
					+ "'"+ Content+"', "
					+ "'"+ FileNames +"', "
					+ "'"+ FileSizes +"')";
				myDB.ExecuteQuery(Query); 
			}

			myDB.DbClose();
			Response.Redirect("List.aspx?TblName="+ TblName);
			Response.End();
		}
	}
}
