using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.Caching;
using System.IO;
using System.Xml;
using System.Collections;

namespace Common
{
	/// <summary>
	/// Function   Դϴ.
	/// </summary>
	public class Function
	{
		//ѱ* Word 
		public string strCut(string str, int max, string suffix)
		{
			string strResult="";
			string s = str.ToString();

			if (s == "") return strResult;

			int count = 0;
			string tmpStr = str.Trim().ToString();
			char [] chrarr = tmpStr.ToCharArray();

			if (tmpStr.Length  != 0)
			{
				for (int i=0; i< chrarr.Length; i++)
				{
					int temp = Convert.ToInt32(chrarr[i]);
					if (temp < 0 || temp >= 128 )
					{
						//ѱ 2byte
						count = count+2;
					} 
					else 
					{
						count = count+1;
					}

					if (count <= max)
					{
						strResult = strResult + tmpStr.Substring(i,1);
					}
					else
					{
						strResult = strResult + suffix;
						break;
					}
				}
			}
			return strResult;
		}


		/// <summary>
		/// ߺϸ üũ
		/// </summary>
		/// <param name="DirName">üũ 丮</param>
		/// <param name="fn">ϸ</param>
		/// <param name="DirName">Ȯ</param>
		public string GetUniqName(string DirName, string fn, string fe) 
		{
			FileInfo info = new FileInfo(DirName+"\\"+fn+fe);
			int i = 1;
			while(true)
			{
				if(info.Exists) 
				{
					info = new FileInfo(DirName+"\\"+fn+"("+i+")"+fe);
					i++;
					continue;
				}
				else 
				{
					break;
				}
			}
			return info.Name;

		}

		public void GetXML(ArrayList myArray, string UserID)
		{
			string XMLDir = HttpContext.Current.Request.MapPath("/Root/Administrator/Account") + @"\XML";	// XML 丮
			string XMLFile = XMLDir +  @"\" + UserID + ".xml";							// XML  File 
			
			XmlTextReader AuthXML = new XmlTextReader(XMLFile);
			
			while (AuthXML.Read())
			{
				switch (AuthXML.NodeType)
				{
					case XmlNodeType.Text:
						myArray.Add(AuthXML.Value.ToString());
						break;
				}
			}
			AuthXML.Close();
		}

		/// <summary>
		/// MsgBox 
		/// </summary>
		/// <param name="strMessage">޼ ڽ  ڿ</param>
		public void PrintMsg(string strMessage) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n" + 
				"		alert('" + strMessage + "');\n//-->\n	</script>\n";

			HttpContext.Current.Response.Write(strHTML);
		}
		
		/// <summary>
		/// MsgBox    â ݴ´.
		/// </summary>
		/// <param name="strMessage">޼ ڽ  ڿ</param>
		public void PrintMsgAndClose(string strMessage) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n		alert('" + strMessage + "');\n" +
				"	self.close();\n" +
				"//-->\n	</script>\n";
			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// MsgBox    𷺼
		/// </summary>
		/// <param name="strMessage">޼ ڽ  ڿ</param>
		/// <param name="redirUri">𷺼 ּ</param>
		public void PrintMsgAndRedir(string strMessage, string redirUri) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n		alert('" + strMessage + "');\n" +
				"	window.document.location.href='" + redirUri + "';\n" +
				"//-->\n	</script>\n";
			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}


		/// <summary>
		/// MsgBox   opener  𷺼
		/// </summary>
		/// <param name="strMessage">Ŭ̾Ʈ µ ڿ</param>
		/// <param name="redirUri">θâ ּ</param>
		public void PrintMsgAndCloseAndOpenerRedir(string strMessage, string redirUri) 
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n	<!--\n		alert('" + strMessage + "');\n" +
				"	opener.document.location.href='" + redirUri + "';\n" +
				"	self.close();\n" +
				"//-->\n	</script>\n";

			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// MsgBox  ȭ ̵
		/// </summary>
		/// <param name="strMessage">Ŭ̾Ʈ µ ڿ</param>
		public void PrintMsgBack(string strMessage)
		{
			string strHTML;
			strHTML = "<script language=\"javascript\">\n" +
				"<!--\n" +
				"alert('" + strMessage + "');\n" +
				"history.back();\n" +
				"//-->\n" +
				"</script>\n";

			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// ޼ڽ    Ÿٿ ش url  ̵
		/// </summary>
		/// <param name="message">  ڿ</param>
		/// <param name="url"> ̵ URI</param>
		/// <param name="target">    </param>
		public void PrintMsgRedirectTarget(string message, string url, string target)
		{
			string strHTML;
			strHTML = "<html>\n" +
				"<body onLoad=\"alert('" + message + "');document.redir.submit();\">\n" +
				"<form action=\"" + url + "\" target=\""+target+"\" name=redir method=post>\n" +
				"<input type=hidden name=name value=''>\n" +
				"</form>\n" +
				"</body>\n" +
				"</html>\n";
			
			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		///  Ÿٿ ش url  ̵
		/// </summary>
		/// <param name="url"> ̵ URI</param>
		/// <param name="target">    </param>
		public void RedirectTarget(string url, string target)
		{
			string strHTML;
			strHTML = "<html>\n" +
				"<body onLoad=\"document.redir.submit();\">\n" +
				"<form action=\"" + url + "\" target=\""+target+"\" name=redir method=post>\n" +
				"<input type=hidden name=name value=''>\n" +
				"</form>\n" +
				"</body>\n" +
				"</html>\n";
			
			HttpContext.Current.Response.Write(strHTML);
			HttpContext.Current.Response.End();
		}

		/// <summary>
		/// ƮѾȿ   ڽƮ ˻Ѵ.
		///  FindControl޼ҵ ڽ ֽ̹ ȿ ˻Ѵ.
		/// </summary>
		/// <param name="o"></param>
		/// <param name="sName"></param>
		/// <returns></returns>
		public Control FindControlAll(Control o, string sName)
		{
			foreach(Control oChild in o.Controls)
			{
				if (oChild.ID == sName)
					return oChild;
				if (oChild.HasControls())
				{
					Control oFind = FindControlAll(oChild, sName);
					if (oFind != null)
						return oFind;
				}
			}

			return null;
		}

		/// <summary>
		/// Page Ŭ ü νź ã 
		/// </summary>
		/// <param name="op">˻ Page Ŭ</param>
		/// <returns>˻ HomlForm ä νź</returns>
		public HtmlForm GetForm(Page op)
		{
			foreach(Control oc in op.Controls)
			{
				if(oc is HtmlForm)
					return (HtmlForm)oc;
			}

			throw new Exception("Find Not Form!!!!!");
		}


		public string ReplaceBR(string str)
		{
			return str.Replace("\n", "<br/>");
		}

		/// <summary>
		/// ڷ Ѿ Ʈ ʱ Ŀ  Ѵ.
		///  ٸ  Լ ȣǾٸ Ͽ Ѵ
		/// </summary>
		/// <param name="oc">Ŀ  Ʈ</param>
		/// <returns> Ŀ   : true,  ̹ Ŀ  Ʈ  : false</returns>
		public bool SetFocus(Control oc)
		{
			if (oc.Page == null)
				throw new Exception("SetFocus ޼ҵ ڴ  ߰ ƮѸ Ͻ  ֽϴ.");

			string ClientFocusScript = @"
<script language=""javascript"">
<!--
function _StartupFocus()
{{
	document.{0}.{1}.focus();
}}

-->
</script>
			";

			if (!oc.Page.IsStartupScriptRegistered("_ClientFocusScript"))
			{
				ClientFocusScript = String.Format(ClientFocusScript, GetForm(oc.Page).ClientID, oc.ClientID);
				oc.Page.RegisterStartupScript("_ClientFocusScript", ClientFocusScript);
				RegisterOnloadFunction(oc.Page, "_StartupFocus()");
				return true;
			}
			else
				return false;
		}

		/// <summary>
		/// Ŭ̾Ʈ Onload̺Ʈ  Լ Ѵ.
		/// </summary>
		/// <param name="page">Page Ŭ</param>
		/// <param name="functionName"> Լ</param>
		public void RegisterOnloadFunction(Page page, string functionName)
		{
			if (!page.IsClientScriptBlockRegistered("_ClientOnloadOnScript"))
			{
				string ClientOnloadOnScript = @"
<script language=""javascript"">
<!--
	function _OnloadExectionFunction()
	{
		for (var i=0; i<__onloadFunctionArray.length; i++)
		{
			eval(__onloadFunctionArray[i]);
		}
	}

	window.onload = _OnloadExectionFunction;
-->
</script>
			";

				page.RegisterClientScriptBlock("_ClientOnloadOnScript", ClientOnloadOnScript);
			}

			page.RegisterArrayDeclaration("__onloadFunctionArray", "'"+ functionName + "'");
		}

		//ٸ    Ű Ʈ Ѵ.
		public void SetObjectToCache(string key, object toCache, int lifeMinute)
		{
			HttpContext.Current.Cache.Insert("__Obj"+key, toCache, null, DateTime.Now.AddMinutes(lifeMinute), TimeSpan.Zero, CacheItemPriority.High, null);
		}

		//ٸ    Ű Ʈ ´.
		public object GetObjectFromCache(string key)
		{
			return HttpContext.Current.Cache["__Obj"+key];
		}

		//ٸ    Ű Ʈ ɽÿ Ѵ.
		public void RemoveObjectCache(string key)
		{
			HttpContext.Current.Cache.Remove("__Obj"+key);
		}
		
	}
}
