<%@ Page language="c#" Codebehind="List.aspx.cs" AutoEventWireup="false" Inherits="Board.List" %>
<%@ Register TagPrefix="ucTop" TagName="Top" Src="Top.ascx" %>
<%@ Register TagPrefix="ucBottom" TagName="Bottom" Src="Bottom.ascx" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
	<HEAD>
		<title>List</title>
		<LINK href="Css/Board.css" type="text/css" rel="stylesheet">
			<script language="javascript" src="./JS/Common.js"></script>
			<script language="javascript">
			function OnSearch() {
				var form = document.List;
				if(!form.txtKeyword.value) {
					window.alert("˻ Է ּ");
					form.txtKeyword.focus();
					return false;
					
				} else if (form.txtKeyword.value.length <= 1) {
					window.alert("˻ ѱ ̻ Է ּ");
					form.txtKeyword.focus();
					return false;
					
				} else {
					return true;
				}
			}
			</script>
	</HEAD>
	<body MS_POSITIONING="FlowLayout">
		<form id="List" method="post" runat="server">
			<ucTop:Top id="Top" runat="server"></ucTop:Top>
			<table cellSpacing="2" cellPadding="0" width="600" border="0">
				<tr>
					<td height="20">[<asp:Label ID="lblPageCount" Runat="server" ForeColor="Red"></asp:Label>]</td>
					<td align="right">
						<asp:label id="lblSearch" runat="server" ForeColor="Black" Width="372px"></asp:label>
						<asp:label id="lblTotal" runat="server"></asp:label>
					</td>
				</tr>
			</table>
			<asp:datalist id="dlList" runat="server" Width="600px">
				<HeaderTemplate>
					<table width="600" border="0" cellspacing="0" cellpadding="2">
						<tr>
							<td bgcolor="#CCCCCC" height="1" colspan="10"></td>
						</tr>
						<tr align="center">
							<td width="30" height="34"><img src="Images/number.gif" width="30" height="18"></td>
							<td width="335"><img src="Images/title.gif" width="41" height="18"></td>
							<td width="50"><img src="Images/file.gif" height="18"></td>
							<td width="75"><img src="Images/writer.gif" width="41" height="18"></td>
							<td width="80"><img src="Images/date.gif" width="41" height="18"></td>
							<td width="30"><img src="Images/count.gif" width="30" height="18"></td>
						</tr>
						<tr>
							<td height="3" bgcolor="#88A4B3" colspan="10"></td>
						</tr>
					</table>
				</HeaderTemplate>
				<ItemTemplate>
					<table width="600" border="0" cellspacing="0" cellpadding="2">
						<tr bgcolor='#FFFFFF' onMouseOver="this.style.backgroundColor='#EEEEEE'" onMouseOut="this.style.backgroundColor='#FFFFFF'">
							<td align="center" width="30">
								<asp:Label id="lblNum" runat="server" Text='<%# DataBinder.Eval(Container,"DataItem.seq") %>'>
								</asp:Label>
							</td>
							<td width="335">
								<asp:Image ID="imgDepth" Runat="server" Visible="False"></asp:Image>
								<asp:Image ID="imgReply" Runat="server" Visible="False"></asp:Image>
								<asp:HyperLink ID="hlSubject" Runat="Server"></asp:HyperLink>
								<asp:Image ID="imgNew" Runat="server" Visible="False"></asp:Image>
							</td>
							<TD width="50" align="center">
								<asp:ImageButton ID="imgBnFile" Runat="server" CommandName="File" Visible="False"></asp:ImageButton>
							</TD>
							<td align="center" width="75">
								<asp:Label id="lblWriter" runat="server"></asp:Label>
							</td>
							<td align="center" width="80">
								<asp:Label id="lblRegDate" runat="server" Text='<%# DataBinder.Eval(Container.DataItem, "regdate", "{0:yyyy-MM-dd}") %>'>
								</asp:Label>
							</td>
							<td align="center" width="30">
								<asp:Label id="lblCount" runat="server" Text='<%# DataBinder.Eval(Container,"DataItem.readcount") %>'>
								</asp:Label>
							</td>
						</tr>
						<tr>
							<td height="1" bgcolor="#CCCCCC" colspan="10"></td>
						</tr>
					</table>
				</ItemTemplate>
			</asp:datalist>
			<table cellSpacing="0" cellPadding="2" width="600" border="0">
				<tr>
					<td>&nbsp;</td>
					<td align="right" width="150">
						<asp:ImageButton id="ibWrite" runat="server" ImageUrl="Images/write.gif" ImageAlign="AbsMiddle"></asp:ImageButton>
						<asp:imagebutton id="ibList" runat="server" ImageAlign="AbsMiddle" Visible="False" ImageUrl="Images/list.gif"></asp:imagebutton>
					</td>
				</tr>
			</table>
			<table style="BORDER-RIGHT: #e6e6e6 1px solid; BORDER-TOP: #e6e6e6 1px solid; BORDER-LEFT: #e6e6e6 1px solid; BORDER-BOTTOM: #e6e6e6 1px solid" cellSpacing="0" cellPadding="0" width="600" bgColor="#f5f5f5" border="0">
				<tr height="35">
					<td align="left"><asp:label id="lblPage" runat="server" Width="320px"></asp:label></td>
					<td align="right"><asp:dropdownlist id="ddlKeyfield" runat="server">
							<asp:ListItem Value="subject" Selected="True"></asp:ListItem>
							<asp:ListItem Value="writer">ۼ</asp:ListItem>
							<asp:ListItem Value="content"></asp:ListItem>
						</asp:dropdownlist><asp:textbox id="txtKeyword" runat="server"></asp:textbox>&nbsp;
						<asp:ImageButton id="ibSearch" runat="server" ImageUrl="Images/search.gif" ImageAlign="AbsMiddle"></asp:ImageButton>
						&nbsp;
					</td>
				</tr>
			</table>
			<ucBottom:Bottom id="Bottom" runat="server"></ucBottom:Bottom>
		</form>
	</body>
</HTML>
